<template>
  <h2>External List of breeds</h2>
  <div class="flex">
    <div>
      <ul v-if="breeds">
        <li v-for="(breed, index) in breeds">
          <button @click="getBreed(breed.id)">{{ breed.name }}</button>
        </li>
      </ul>
    </div>
    <div v-if="selectedBreed.photo" class="selected-breed">
      <h2 class="title">Selected Breed</h2>
      <h3>{{ selectedBreed.name }}</h3>
      <p><strong>Bred For:</strong> {{ selectedBreed.bred_for }}</p>
      <img :src="selectedBreed.photo" :alt="selectedBreed.name">
    </div>
  </div>
</template>

<script setup>
import {ref, reactive, onMounted} from 'vue'

const breeds = ref(null)
const selectedBreed = reactive({
  name: '',
  bred_for: '',
  photo: ''
})

async function getDogsList() {
  const data = await fetch('https://api.thedogapi.com/v1/breeds?limit=10', {
    type: 'GET'
  }).then(response => response.json())
  console.log(data)
  if (data.length > 0) {
    breeds.value = data
  }
}

async function getBreed(breedId = null) {
  let url = `https://api.thedogapi.com/v1/breeds/${breedId}`

  const data = await fetch(url, {
    type: 'GET'
  }).then(response => response.json())
  console.log(data)
  if (data.reference_image_id !== undefined) {
    selectedBreed.name = data.name
    selectedBreed.bred_for = data.bred_for
    getBreedImage(data.reference_image_id)
  }
}

async function getBreedImage(breedImageId = null) {
  let url = `https://api.thedogapi.com/v1/images/${breedImageId}`
  const data = await fetch(url, {
    type: 'GET'
  }).then(response => response.json())
  console.log(data)
  selectedBreed.photo = data.url
}

onMounted(() => {
  getDogsList()
})
</script>

<style>
.selected-breed h2.title {
  margin-top: 0;
}
.selected-breed {
  padding-left: 2em;
}
.flex {
  display: flex;
  flex-direction: row;
}
</style>
